<?php

namespace CADSUP\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class RegiaoService {
    
    protected $connection;
    
    public function __construct($entityManager, $environment){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    public function deleteRegiao ($row){

		$param = array();
        $param['P_CDREGIAO'] = $row['CDREGIAO'];
        $query = "DELETE REGIAO WHERE CDREGIAO = :P_CDREGIAO";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function deleteFilial ($row){
    	
    	$param = array();
        $param['P_CDREGIAO'] = $row['CDREGIAO'];
    	$query = "UPDATE FILIAL SET CDREGIAO = null WHERE CDREGIAO = :P_CDREGIAO";
		try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function deleteMunicipio ($row){
    	
    	$param = array();
        $param['P_CDREGIAO'] = $row['CDREGIAO'];
    	$query = "UPDATE MUNICIPIO SET CDREGIAO = '' WHERE CDREGIAO = :P_CDREGIAO";
		try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function insertMunicipio ($row){
    	
    	$param = array();
        $param['P_CDREGIAO'] = $row['CDREGIAO'];
        $param['P_CDPAIS']   = $row['CDPAIS'];
        $param['P_SGESTADO'] = $row['SGESTADO'];
        $param['P_CDMUNICIPIO'] = $row['CDMUNICIPIO'];
        
        
    	$query = "UPDATE MUNICIPIO SET CDREGIAO = :P_CDREGIAO WHERE CDPAIS = :P_CDPAIS AND SGESTADO = :P_SGESTADO AND CDMUNICIPIO = :P_CDMUNICIPIO";
		try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    
    public function verificaFilial ($row){
    	
    	$param = array();
        $param['P_CDREGIAO'] = $row['CDREGIAO'];
        $param['P_CDFILIAL'] = $row['CDFILIAL'];
        $param['P_TCDREGIAO'] = $row['TCDREGIAO'];
    	$query = "SELECT
                   FILIAL.CDREGIAO, CDFILIAL
                FROM
                   FILIAL
                WHERE
                   (FILIAL.CDFILIAL = :P_CDFILIAL) AND
                   (FILIAL.CDREGIAO = :P_CDREGIAO OR :P_TCDREGIAO = 'T')";
		try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            $retorno = $std->fetchAll();
            return $retorno;
        } catch (Exception $e){
            throw $e;
        }
    }
    
}