/* Tabela RETIRADA: Retirada */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela RETIRADA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Retirada,
             utilizando a tabela Geral de Logs de Operaes */

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'LOG_PLA_RETIRADA'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER LOG_PLA_RETIRADA
GO

CREATE TRIGGER LOG_PLA_RETIRADA
ON RETIRADA
AFTER DELETE, INSERT, UPDATE
AS
BEGIN
  DECLARE @V_USUARIO    VARCHAR(40);
  DECLARE @V_TIPO       VARCHAR(1);
  DECLARE @V_ITPESQ     VARCHAR(40);
  DECLARE @V_DESC       VARCHAR(500);
  DECLARE @V_DTOPER     DATETIME;

  DECLARE  @V_DSREMOTEADDR     VARCHAR(15);
  DECLARE  @V_DSREMOTEHOST     VARCHAR(15);
  DECLARE  @V_DSSERVERRDM      VARCHAR(20);
  DECLARE  @V_DSSERVMETHOD     VARCHAR(30);
  DECLARE  @V_DSREMOTEOPER     VARCHAR(12);



/* Variveis do cursor */
   DECLARE @V_IDCOMANDO          VARCHAR(1);

   DECLARE @V_NEW_CDFILIAL       VARCHAR(4);
   DECLARE @V_NEW_NRCARDAPIO     VARCHAR(10);
   DECLARE @V_NEW_NRRETIRADA     VARCHAR(10);
   DECLARE @V_NEW_DTRETIRADA     DATETIME;
   DECLARE @V_NEW_NRREQUEXTRRE   VARCHAR(10);
   DECLARE @V_NEW_CDFILANCESTQ   VARCHAR(4);
   DECLARE @V_NEW_NRLANCESTQ     VARCHAR(10);
   DECLARE @V_NEW_IDRETIPRAT     VARCHAR(1);

   DECLARE @V_OLD_CDFILIAL       VARCHAR(4);
   DECLARE @V_OLD_NRCARDAPIO     VARCHAR(10);
   DECLARE @V_OLD_NRRETIRADA     VARCHAR(10);
   DECLARE @V_OLD_DTRETIRADA     DATETIME;
   DECLARE @V_OLD_NRREQUEXTRRE   VARCHAR(10);
   DECLARE @V_OLD_CDFILANCESTQ   VARCHAR(4);
   DECLARE @V_OLD_NRLANCESTQ     VARCHAR(10);
   DECLARE @V_OLD_IDRETIPRAT     VARCHAR(1);
  



   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER

   SET @V_USUARIO = ISNULL(@V_USUARIO, '');


   DECLARE C_DADOS CURSOR FOR
      SELECT
         'D' IDCOMANDO,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          CDFILIAL,
          NRCARDAPIO,
          NRRETIRADA,
          DTRETIRADA,
          NRREQUEXTRRE,
          CDFILANCESTQ,
          NRLANCESTQ,
          IDRETIPRAT
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
          INSERTED.CDFILIAL,
          INSERTED.NRCARDAPIO,
          INSERTED.NRRETIRADA,
          INSERTED.DTRETIRADA,
          INSERTED.NRREQUEXTRRE,
          INSERTED.CDFILANCESTQ,
          INSERTED.NRLANCESTQ,
          INSERTED.IDRETIPRAT,
          DELETED.CDFILIAL,
          DELETED.NRCARDAPIO,
          DELETED.NRRETIRADA,
          DELETED.DTRETIRADA,
          DELETED.NRREQUEXTRRE,
          DELETED.CDFILANCESTQ,
          DELETED.NRLANCESTQ,
          DELETED.IDRETIPRAT
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDFILIAL      =  DELETED.CDFILIAL    AND
         INSERTED.NRCARDAPIO    =  DELETED.NRCARDAPIO  AND
         INSERTED.NRRETIRADA    =  DELETED.NRRETIRADA

      UNION ALL

      SELECT
         'I' IDCOMANDO,
          CDFILIAL,
          NRCARDAPIO,
          NRRETIRADA,
          DTRETIRADA,
          NRREQUEXTRRE,
          CDFILANCESTQ,
          NRLANCESTQ,
          IDRETIPRAT,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)
  
   OPEN C_DADOS;
   FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                @V_NEW_CDFILIAL,
                                @V_NEW_NRCARDAPIO,
                                @V_NEW_NRRETIRADA,
                                @V_NEW_DTRETIRADA,
                                @V_NEW_NRREQUEXTRRE,
                                @V_NEW_CDFILANCESTQ,
                                @V_NEW_NRLANCESTQ,
                                @V_NEW_IDRETIPRAT,
                                @V_OLD_CDFILIAL,
                                @V_OLD_NRCARDAPIO,
                                @V_OLD_NRRETIRADA,
                                @V_OLD_DTRETIRADA,
                                @V_OLD_NRREQUEXTRRE,
                                @V_OLD_CDFILANCESTQ,
                                @V_OLD_NRLANCESTQ, 
                                @V_OLD_IDRETIPRAT

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_IDCOMANDO = 'D' /* Deleting */ BEGIN
         SET @V_DESC = @V_DESC + 'Fili=' + @V_OLD_CDFILIAL;
         SET @V_DESC = @V_DESC + ' Card=' + @V_OLD_NRCARDAPIO;
         SET @V_DESC = @V_DESC + ' Reti=' + @V_OLD_NRRETIRADA;
         SET @V_DESC = @V_DESC + ' DataReti=' + CONVERT(VARCHAR, @V_OLD_DTRETIRADA, 12);
         IF (ISNULL(@V_OLD_NRREQUEXTRRE, '!') <> '!') BEGIN
            SET @V_DESC = @V_DESC + ' RequExt=' + @V_OLD_NRREQUEXTRRE;
         END;

         IF (ISNULL(@V_OLD_CDFILANCESTQ, '!') <> '!') BEGIN
            SET @V_DESC = @V_DESC + ' FiliEst=' + @V_OLD_CDFILANCESTQ;
         END;

         IF (ISNULL(@V_OLD_NRLANCESTQ, '!') <> '!') BEGIN
            SET @V_DESC = @V_DESC + ' Lanto=' + @V_OLD_NRLANCESTQ;
         END;

         IF (ISNULL(@V_OLD_IDRETIPRAT, '!') <> '!') BEGIN
            SET @V_DESC = @V_DESC + ' RetiPrat=' + @V_OLD_IDRETIPRAT;
         END;
         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_OLD_CDFILIAL   + 
                         @V_OLD_NRRETIRADA + 
                         CONVERT(VARCHAR, @V_OLD_DTRETIRADA, 12) + 
                         @V_OLD_NRLANCESTQ;
      END
      ELSE BEGIN
         IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
            IF (@V_OLD_CDFILIAL   <> @V_NEW_CDFILIAL  ) OR
               (@V_OLD_NRCARDAPIO <> @V_NEW_NRCARDAPIO) OR
               (@V_OLD_NRRETIRADA <> @V_NEW_NRRETIRADA) OR
               (@V_OLD_DTRETIRADA <> @V_NEW_DTRETIRADA) OR
               (ISNULL(@V_OLD_NRREQUEXTRRE, '!') <> ISNULL(@V_NEW_NRREQUEXTRRE, '!')) OR
               (ISNULL(@V_OLD_CDFILANCESTQ, '!') <> ISNULL(@V_NEW_CDFILANCESTQ, '!')) OR
               (ISNULL(@V_OLD_NRLANCESTQ,   '!') <> ISNULL(@V_NEW_NRLANCESTQ,   '!')) OR
               (ISNULL(@V_OLD_IDRETIPRAT,   '!') <> ISNULL(@V_NEW_IDRETIPRAT,   '!'))
                            
               SET @V_TIPO   = '2';
               SET @V_ITPESQ = @V_OLD_CDFILIAL + 
                               @V_OLD_NRRETIRADA +
                               CONVERT(VARCHAR, @V_OLD_DTRETIRADA, 12) +
                               @V_OLD_NRLANCESTQ;
            END;
         ELSE BEGIN
            SET @V_TIPO   = '1';
            SET @V_ITPESQ = @V_NEW_CDFILIAL +
                            @v_NEW_NRRETIRADA +
                            CONVERT(VARCHAR, @V_NEW_DTRETIRADA, 12) +
                            @V_NEW_NRLANCESTQ;
         END;
      
         IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
            IF (@V_OLD_CDFILIAL <> @V_NEW_CDFILIAL) BEGIN
               SET @V_DESC = @V_DESC + 'Fili=' + @V_OLD_CDFILIAL + '|' + @V_NEW_CDFILIAL;   
            END 
            ELSE BEGIN
               SET @V_DESC = @V_DESC + 'Fili=' + @V_OLD_CDFILIAL;
            END;
         END
         ELSE BEGIN
            SET @V_DESC = @V_DESC + 'Fili=' + @V_NEW_CDFILIAL;   
         END;
         IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
            IF (@V_OLD_NRCARDAPIO <> @V_NEW_NRCARDAPIO) BEGIN
               SET @V_DESC = @V_DESC + ' Card=' + @V_OLD_NRCARDAPIO + '|' + @V_NEW_NRCARDAPIO;   
            END
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' Card=' + @V_OLD_NRCARDAPIO;
            END;
         END
         ELSE BEGIN
             SET @V_DESC = @V_DESC + ' Card=' + @V_NEW_NRCARDAPIO;   
         END;
         IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
            IF (@V_OLD_NRRETIRADA <> @V_NEW_NRRETIRADA) BEGIN
               SET @V_DESC = @V_DESC + ' Reti=' + @V_OLD_NRRETIRADA + '|' + @V_NEW_NRRETIRADA;   
            END   
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' Reti=' + @V_OLD_NRRETIRADA;
            END;
         END
         ELSE BEGIN
            SET @V_DESC = @V_DESC + ' Reti=' + @V_NEW_NRRETIRADA;   
         END;

         IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
            IF (@V_OLD_DTRETIRADA <> @V_NEW_DTRETIRADA) BEGIN
               SET @V_DESC = @V_DESC + ' DataReti de=' + CONVERT(VARCHAR, @V_OLD_DTRETIRADA, 12) + ' para=' + CONVERT(VARCHAR, @V_NEW_DTRETIRADA, 12);
            END 
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' DataReti=' + CONVERT(VARCHAR, @V_OLD_DTRETIRADA, 12);
            END;
         END
         ELSE BEGIN
            SET @V_DESC = @V_DESC + ' DataReti=' + CONVERT(VARCHAR, @V_NEW_DTRETIRADA, 12);   
         END;


         IF (ISNULL(@V_NEW_NRREQUEXTRRE, '!') <> '!') OR (@V_IDCOMANDO = 'U' AND (ISNULL(@V_NEW_NRREQUEXTRRE, '!') = '!')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_NRREQUEXTRRE, '!') <> ISNULL(@V_NEW_NRREQUEXTRRE, '!')) BEGIN
                  SET @V_DESC = @V_DESC + ' RequExt de=' + @V_OLD_NRREQUEXTRRE + ' para=' + @V_NEW_NRREQUEXTRRE;   
               END;  
            END   
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' RequExt=' + @V_NEW_NRREQUEXTRRE;
            END;
         END;
         IF (ISNULL(@V_NEW_CDFILANCESTQ, '!') <> '!') OR (@V_IDCOMANDO = 'U' AND (ISNULL(@V_NEW_CDFILANCESTQ, '!') = '!')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_CDFILANCESTQ, '!') <> ISNULL(@V_NEW_CDFILANCESTQ, '!')) BEGIN
                  SET @V_DESC = @V_DESC + ' FiliEst de=' + @V_OLD_CDFILANCESTQ + ' para=' + @V_NEW_CDFILANCESTQ;   
               END;  
            END   
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' FiliEst=' + @V_NEW_CDFILANCESTQ;
            END;
         END;
         IF (ISNULL(@V_NEW_NRLANCESTQ, '!') <> '!') OR (@V_IDCOMANDO = 'U' AND (ISNULL(@V_NEW_NRLANCESTQ, '!') = '!')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_NRLANCESTQ, '!') <> ISNULL(@V_NEW_NRLANCESTQ, '!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Lanto de=' + @V_OLD_NRLANCESTQ + ' para=' + @V_NEW_NRLANCESTQ;   
               END;  
            END   
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' Lanto=' + @V_NEW_NRLANCESTQ;
            END;
         END;
         IF (ISNULL(@V_NEW_IDRETIPRAT, '!') <> '!') OR (@V_IDCOMANDO = 'U' AND (ISNULL(@V_NEW_IDRETIPRAT, '!') = '!')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_IDRETIPRAT, '!') <> ISNULL(@V_NEW_IDRETIPRAT, '!')) BEGIN
                  SET @V_DESC = @V_DESC + ' RetiPrat de=' + @V_OLD_IDRETIPRAT + ' para=' + @V_NEW_IDRETIPRAT;   
               END;  
            END   
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' RetiPrat=' + @V_NEW_IDRETIPRAT;
            END;
         END;
      END;
      IF @V_TIPO <> '0' BEGIN
         SET @V_USUARIO = '  ';
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               SELECT 
                  @V_DSSERVERRDM  = DSSERVERRDM, 
                  @V_DSREMOTEADDR = DSREMOTEADDR, 
                  @V_DSREMOTEHOST = DSREMOTEHOST,
    	          @V_DSSERVMETHOD = DSSERVMETHOD, 
                  @V_DSREMOTEOPER = DSREMOTEOPER
      	       FROM 
                  SQLWEBTUNNING;
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                   DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
               VALUES
                  ('RETIRADA', @V_DTOPER, @V_USUARIO, @V_TIPO, @V_ITPESQ, SUBSTRING(@V_DESC, 1, 300),
                   @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER, ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL));
            END;
         END;
      END;

      FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                   @V_NEW_CDFILIAL,
                                   @V_NEW_NRCARDAPIO,
                                   @V_NEW_NRRETIRADA,
                                   @V_NEW_DTRETIRADA,
                                   @V_NEW_NRREQUEXTRRE,
                                   @V_NEW_CDFILANCESTQ,
                                   @V_NEW_NRLANCESTQ,
                                   @V_NEW_IDRETIPRAT,
                                   @V_OLD_CDFILIAL,
                                   @V_OLD_NRCARDAPIO,
                                   @V_OLD_NRRETIRADA,
                                   @V_OLD_DTRETIRADA,
                                   @V_OLD_NRREQUEXTRRE,
                                   @V_OLD_CDFILANCESTQ,
                                   @V_OLD_NRLANCESTQ, 
                                   @V_OLD_IDRETIPRAT
   END;
   CLOSE      C_DADOS;
   DEALLOCATE C_DADOS;
END;
GO


 

-- VERSAO --
EXEC ATUVEROBJ 'LOG_PLA_RETIRADA','5.01.016';
GO

